package com.ynet.life.action;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.life.base.LifeDBAccess;
import java.math.BigDecimal;
import java.sql.Connection;
import java.util.ArrayList;
import java.util.List;

/* loaded from: com_ynet_life_action.jar:com/ynet/life/action/CalculateTransferFeeAction.class */
public class CalculateTransferFeeAction extends LifeJDBCAction {
    private static final String PERBANK_REGUL_TRANS_SQL = "select FEN_MODE,FEN_AMOUNT,FEN_MINAMOUNT,FEN_MAXAMOUNT,FEN_AMOUNTSTR from IM_FEE_ITEM where  FEN_BSNCODE='1' and FEN_TYPE in (0,1)";
    private static final String PERBANK_HURRY_TRANS_SQL = "select FEN_MODE,FEN_AMOUNT,FEN_MINAMOUNT,FEN_MAXAMOUNT,FEN_AMOUNTSTR from IM_FEE_ITEM where  FEN_BSNCODE='2' and FEN_TYPE in (0,1)";
    private String payAmount;
    private String remitType;
    private String accountNo;

    public String getPayAmount() {
        return this.payAmount;
    }

    public void setPayAmount(String payAmount) {
        this.payAmount = payAmount;
    }

    public String getRemitType() {
        return this.remitType;
    }

    public void setRemitType(String remitType) {
        this.remitType = remitType;
    }

    public String execute(Context context) throws GENEException {
        if (this.payAmount == null) {
            throw new GENEException("CalculateTransferFeeAction define error, paramater named payAmount not set!");
        }
        if (this.remitType == null) {
            throw new GENEException("CalculateTransferFeeAction define error, paramater named remitType not set!");
        }
        if (((String) context.getDataValue(this.remitType)) == null || "".equals((String) context.getDataValue(this.remitType))) {
            context.setDataValue("chargeFee", "0.00");
            return "0";
        }
        int remitType = Integer.parseInt((String) context.getDataValue(this.remitType));
        String payAmount = (String) context.getDataValue(this.payAmount);
        context.getDataValue(this.accountNo);
        String bankId = (String) context.getDataValue("bankId");
        if (remitType == 0 || remitType == 1) {
            String chargeFee = calculatePerBankChargeFee(remitType, payAmount, context, bankId);
            context.setDataValue("chargeFee", chargeFee);
            return "0";
        }
        context.setDataValue("chargeFee", "0.00");
        return "0";
    }

    private String calculatePerBankChargeFee(int remitType, String payAmount, Context context, String bankId) throws GENEException {
        List list = null;
        if (remitType == 0) {
            String SqlString = "select FEN_MODE,FEN_AMOUNT,FEN_MINAMOUNT,FEN_MAXAMOUNT,FEN_AMOUNTSTR from IM_FEE_ITEM where  FEN_BSNCODE='1' and FEN_TYPE in (0,1)and FEN_BANKID ='" + bankId + "'";
            list = getResult(SqlString, context);
        } else if (remitType == 1) {
            String SqlString2 = "select FEN_MODE,FEN_AMOUNT,FEN_MINAMOUNT,FEN_MAXAMOUNT,FEN_AMOUNTSTR from IM_FEE_ITEM where  FEN_BSNCODE='2' and FEN_TYPE in (0,1)and FEN_BANKID ='" + bankId + "'";
            list = getResult(SqlString2, context);
        }
        BigDecimal chargeFee = new BigDecimal(0);
        if (list.size() != 0) {
            int mode = Integer.parseInt((String) list.get(0));
            BigDecimal amountSingle = new BigDecimal((String) list.get(1));
            BigDecimal mini = new BigDecimal((String) list.get(2));
            BigDecimal max = new BigDecimal((String) list.get(3));
            String amountStr = (String) list.get(4);
            BigDecimal amount = new BigDecimal(payAmount);
            if (mode == 0) {
                chargeFee = amountSingle;
            } else if (mode == 2) {
                BigDecimal rate = amountSingle.divide(new BigDecimal(100));
                chargeFee = rate.multiply(amount).compareTo(mini) <= 0 ? mini : rate.multiply(amount).compareTo(max) >= 0 ? max : rate.multiply(amount);
            } else if (mode == 3) {
                String[][] amountString = new String[6][4];
                if (amountStr != null && amountStr.trim().length() != 0) {
                    String[] amt = amountStr.split("\\|");
                    for (int j = 0; j < amt.length; j++) {
                        String[] aa = amt[j].split("\\,");
                        for (int k = 0; k < aa.length; k++) {
                            amountString[j][k] = aa[k];
                        }
                    }
                    if (amount.compareTo(new BigDecimal(amountString[5][0])) > 0) {
                        if (Integer.parseInt(amountString[5][1]) == 1) {
                            chargeFee = new BigDecimal(amountString[5][2]).add(new BigDecimal(amountString[5][3]));
                        } else if (Integer.parseInt(amountString[5][1]) == 2) {
                            chargeFee = amount.multiply(new BigDecimal(amountString[5][2]).divide(new BigDecimal(10000))).add(new BigDecimal(amountString[5][3]));
                        }
                    } else {
                        int m = 0;
                        while (true) {
                            if (m >= 6) {
                                break;
                            }
                            if (amount.compareTo(new BigDecimal(amountString[m][0])) > 0) {
                                m++;
                            } else {
                                if (Integer.parseInt(amountString[m][1]) == 1) {
                                    chargeFee = new BigDecimal(amountString[m][2]).add(new BigDecimal(amountString[m][3]));
                                }
                                if (Integer.parseInt(amountString[m][1]) == 2) {
                                    chargeFee = amount.multiply(new BigDecimal(amountString[m][2]).divide(new BigDecimal(10000))).add(new BigDecimal(amountString[m][3]));
                                }
                            }
                        }
                    }
                }
            }
        }
        return chargeFee.divide(new BigDecimal("1"), 2, 4).toString();
    }

    private List getResult(String sql, Context context) throws GENEException {
        Connection conn = LifeDBAccess.getConnection(getDataSource());
        new ArrayList();
        try {
            List list = LifeDBAccess.querySingleResult(conn, sql, (List) null, 5);
            return list;
        } finally {
            LifeDBAccess.releaseConnection(getDataSource(), conn);
        }
    }

    public String getAccountNo() {
        return this.accountNo;
    }

    public void setAccountNo(String accountNo) {
        this.accountNo = accountNo;
    }
}
